#ifndef GUTS_VECTOR_HPP
#define GUTS_VECTOR_HPP


#if _MSC_VER >= 1600 
#include "msvc100stdvectorfix.hpp"
#elif _MSC_VER >= 1500
#include "msvc90stdvectorfix.hpp"
#elif _MSC_VER >= 1400
#include "msvc80stdvectorfix.hpp"
#else
#include <vector>
#endif

#include "Allocator.hpp"

namespace guts
{ 
    template <typename T, typename Alloc>
    struct VectorFix
    {
#if _MSC_VER >= 1400
        typedef std::vectorfix<T, Alloc > RT;
#else
        typedef std::vector<T, Alloc > RT;
#endif 
    };
    
    template <typename T>
    struct Vector
    {
        typedef typename VectorFix<T, Allocator<T> >::RT RT;
    };
} 

#endif
